# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ChartSourceQuery(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChartSourceQuery - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'querybuilder_serialization': 'str',
            'scatter_plot_source': 'str',
            'secondary_axis': 'bool',
            'source_description': 'str',
            'querybuilder_enabled': 'bool',
            'name': 'str',
            'query': 'str',
            'disabled': 'bool'
        }

        self.attribute_map = {
            'querybuilder_serialization': 'querybuilderSerialization',
            'scatter_plot_source': 'scatterPlotSource',
            'secondary_axis': 'secondaryAxis',
            'source_description': 'sourceDescription',
            'querybuilder_enabled': 'querybuilderEnabled',
            'name': 'name',
            'query': 'query',
            'disabled': 'disabled'
        }

        self._querybuilder_serialization = None
        self._scatter_plot_source = None
        self._secondary_axis = None
        self._source_description = None
        self._querybuilder_enabled = None
        self._name = None
        self._query = None
        self._disabled = None

    @property
    def querybuilder_serialization(self):
        """
        Gets the querybuilder_serialization of this ChartSourceQuery.
        Opaque representation of the querybuilder

        :return: The querybuilder_serialization of this ChartSourceQuery.
        :rtype: str
        """
        return self._querybuilder_serialization

    @querybuilder_serialization.setter
    def querybuilder_serialization(self, querybuilder_serialization):
        """
        Sets the querybuilder_serialization of this ChartSourceQuery.
        Opaque representation of the querybuilder

        :param querybuilder_serialization: The querybuilder_serialization of this ChartSourceQuery.
        :type: str
        """
        self._querybuilder_serialization = querybuilder_serialization

    @property
    def scatter_plot_source(self):
        """
        Gets the scatter_plot_source of this ChartSourceQuery.
        For scatter plots, does this query source the X-axis or the Y-axis

        :return: The scatter_plot_source of this ChartSourceQuery.
        :rtype: str
        """
        return self._scatter_plot_source

    @scatter_plot_source.setter
    def scatter_plot_source(self, scatter_plot_source):
        """
        Sets the scatter_plot_source of this ChartSourceQuery.
        For scatter plots, does this query source the X-axis or the Y-axis

        :param scatter_plot_source: The scatter_plot_source of this ChartSourceQuery.
        :type: str
        """
        allowed_values = ["X", "Y"]
        if scatter_plot_source not in allowed_values:
            raise ValueError(
                "Invalid value for `scatter_plot_source`, must be one of {0}"
                .format(allowed_values)
            )
        self._scatter_plot_source = scatter_plot_source

    @property
    def secondary_axis(self):
        """
        Gets the secondary_axis of this ChartSourceQuery.
        Determines if this source relates to the right hand Y-axis or not

        :return: The secondary_axis of this ChartSourceQuery.
        :rtype: bool
        """
        return self._secondary_axis

    @secondary_axis.setter
    def secondary_axis(self, secondary_axis):
        """
        Sets the secondary_axis of this ChartSourceQuery.
        Determines if this source relates to the right hand Y-axis or not

        :param secondary_axis: The secondary_axis of this ChartSourceQuery.
        :type: bool
        """
        self._secondary_axis = secondary_axis

    @property
    def source_description(self):
        """
        Gets the source_description of this ChartSourceQuery.
        A description for the purpose of this source

        :return: The source_description of this ChartSourceQuery.
        :rtype: str
        """
        return self._source_description

    @source_description.setter
    def source_description(self, source_description):
        """
        Sets the source_description of this ChartSourceQuery.
        A description for the purpose of this source

        :param source_description: The source_description of this ChartSourceQuery.
        :type: str
        """
        self._source_description = source_description

    @property
    def querybuilder_enabled(self):
        """
        Gets the querybuilder_enabled of this ChartSourceQuery.
        Whether or not this source line should have the query builder enabled

        :return: The querybuilder_enabled of this ChartSourceQuery.
        :rtype: bool
        """
        return self._querybuilder_enabled

    @querybuilder_enabled.setter
    def querybuilder_enabled(self, querybuilder_enabled):
        """
        Sets the querybuilder_enabled of this ChartSourceQuery.
        Whether or not this source line should have the query builder enabled

        :param querybuilder_enabled: The querybuilder_enabled of this ChartSourceQuery.
        :type: bool
        """
        self._querybuilder_enabled = querybuilder_enabled

    @property
    def name(self):
        """
        Gets the name of this ChartSourceQuery.
        Name of the source

        :return: The name of this ChartSourceQuery.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ChartSourceQuery.
        Name of the source

        :param name: The name of this ChartSourceQuery.
        :type: str
        """
        self._name = name

    @property
    def query(self):
        """
        Gets the query of this ChartSourceQuery.
        Query expression to plot on the chart

        :return: The query of this ChartSourceQuery.
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """
        Sets the query of this ChartSourceQuery.
        Query expression to plot on the chart

        :param query: The query of this ChartSourceQuery.
        :type: str
        """
        self._query = query

    @property
    def disabled(self):
        """
        Gets the disabled of this ChartSourceQuery.
        Whether the source is disabled

        :return: The disabled of this ChartSourceQuery.
        :rtype: bool
        """
        return self._disabled

    @disabled.setter
    def disabled(self, disabled):
        """
        Sets the disabled of this ChartSourceQuery.
        Whether the source is disabled

        :param disabled: The disabled of this ChartSourceQuery.
        :type: bool
        """
        self._disabled = disabled

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

