# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class FacetsSearchRequestContainer(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FacetsSearchRequestContainer - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'facets': 'list[str]',
            'facet_query': 'str',
            'facet_query_matching_method': 'str',
            'query': 'list[SearchQuery]',
            'limit': 'int'
        }

        self.attribute_map = {
            'facets': 'facets',
            'facet_query': 'facetQuery',
            'facet_query_matching_method': 'facetQueryMatchingMethod',
            'query': 'query',
            'limit': 'limit'
        }

        self._facets = None
        self._facet_query = None
        self._facet_query_matching_method = None
        self._query = None
        self._limit = None

    @property
    def facets(self):
        """
        Gets the facets of this FacetsSearchRequestContainer.
        A list of facets (property keys) to return values from found in entities matching 'query'.  Examples are 'tags', 'creatorId', etc

        :return: The facets of this FacetsSearchRequestContainer.
        :rtype: list[str]
        """
        return self._facets

    @facets.setter
    def facets(self, facets):
        """
        Sets the facets of this FacetsSearchRequestContainer.
        A list of facets (property keys) to return values from found in entities matching 'query'.  Examples are 'tags', 'creatorId', etc

        :param facets: The facets of this FacetsSearchRequestContainer.
        :type: list[str]
        """
        self._facets = facets

    @property
    def facet_query(self):
        """
        Gets the facet_query of this FacetsSearchRequestContainer.
        A string against which facet results are compared.  If the facet result either CONTAINs, STARTSWITH, or is an EXACT match for this value, as specified by facetQueryMatchingMethod, then it is returned

        :return: The facet_query of this FacetsSearchRequestContainer.
        :rtype: str
        """
        return self._facet_query

    @facet_query.setter
    def facet_query(self, facet_query):
        """
        Sets the facet_query of this FacetsSearchRequestContainer.
        A string against which facet results are compared.  If the facet result either CONTAINs, STARTSWITH, or is an EXACT match for this value, as specified by facetQueryMatchingMethod, then it is returned

        :param facet_query: The facet_query of this FacetsSearchRequestContainer.
        :type: str
        """
        self._facet_query = facet_query

    @property
    def facet_query_matching_method(self):
        """
        Gets the facet_query_matching_method of this FacetsSearchRequestContainer.
        The matching method used to filter when 'facetQuery' is used. Defaults to CONTAINS.

        :return: The facet_query_matching_method of this FacetsSearchRequestContainer.
        :rtype: str
        """
        return self._facet_query_matching_method

    @facet_query_matching_method.setter
    def facet_query_matching_method(self, facet_query_matching_method):
        """
        Sets the facet_query_matching_method of this FacetsSearchRequestContainer.
        The matching method used to filter when 'facetQuery' is used. Defaults to CONTAINS.

        :param facet_query_matching_method: The facet_query_matching_method of this FacetsSearchRequestContainer.
        :type: str
        """
        allowed_values = ["CONTAINS", "STARTSWITH", "EXACT", "TAGPATH"]
        if facet_query_matching_method not in allowed_values:
            raise ValueError(
                "Invalid value for `facet_query_matching_method`, must be one of {0}"
                .format(allowed_values)
            )
        self._facet_query_matching_method = facet_query_matching_method

    @property
    def query(self):
        """
        Gets the query of this FacetsSearchRequestContainer.
        A list of queries by which to limit the search results.  Entities that match ALL queries in this list constitute a set of 'entity search results'.  All facets listed in the 'facets' search parameter of all entities within 'entity search results' are scanned to produce the search results (of facet values).

        :return: The query of this FacetsSearchRequestContainer.
        :rtype: list[SearchQuery]
        """
        return self._query

    @query.setter
    def query(self, query):
        """
        Sets the query of this FacetsSearchRequestContainer.
        A list of queries by which to limit the search results.  Entities that match ALL queries in this list constitute a set of 'entity search results'.  All facets listed in the 'facets' search parameter of all entities within 'entity search results' are scanned to produce the search results (of facet values).

        :param query: The query of this FacetsSearchRequestContainer.
        :type: list[SearchQuery]
        """
        self._query = query

    @property
    def limit(self):
        """
        Gets the limit of this FacetsSearchRequestContainer.
        The number of results to return.  Default 100

        :return: The limit of this FacetsSearchRequestContainer.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """
        Sets the limit of this FacetsSearchRequestContainer.
        The number of results to return.  Default 100

        :param limit: The limit of this FacetsSearchRequestContainer.
        :type: int
        """
        self._limit = limit

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

