# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Message(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Message - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'target': 'str',
            'attributes': 'dict(str, str)',
            'content': 'str',
            'scope': 'str',
            'start_epoch_millis': 'int',
            'end_epoch_millis': 'int',
            'display': 'str',
            'title': 'str',
            'severity': 'str',
            'read': 'bool',
            'source': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'target': 'target',
            'attributes': 'attributes',
            'content': 'content',
            'scope': 'scope',
            'start_epoch_millis': 'startEpochMillis',
            'end_epoch_millis': 'endEpochMillis',
            'display': 'display',
            'title': 'title',
            'severity': 'severity',
            'read': 'read',
            'source': 'source'
        }

        self._id = None
        self._target = None
        self._attributes = None
        self._content = None
        self._scope = None
        self._start_epoch_millis = None
        self._end_epoch_millis = None
        self._display = None
        self._title = None
        self._severity = None
        self._read = None
        self._source = None

    @property
    def id(self):
        """
        Gets the id of this Message.


        :return: The id of this Message.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Message.


        :param id: The id of this Message.
        :type: str
        """
        self._id = id

    @property
    def target(self):
        """
        Gets the target of this Message.
        For scope=CUSTOMER or scope=USER, the individual customer or user id

        :return: The target of this Message.
        :rtype: str
        """
        return self._target

    @target.setter
    def target(self, target):
        """
        Sets the target of this Message.
        For scope=CUSTOMER or scope=USER, the individual customer or user id

        :param target: The target of this Message.
        :type: str
        """
        self._target = target

    @property
    def attributes(self):
        """
        Gets the attributes of this Message.
        A string->string map of additional properties associated with this message

        :return: The attributes of this Message.
        :rtype: dict(str, str)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Sets the attributes of this Message.
        A string->string map of additional properties associated with this message

        :param attributes: The attributes of this Message.
        :type: dict(str, str)
        """
        self._attributes = attributes

    @property
    def content(self):
        """
        Gets the content of this Message.
        Message content

        :return: The content of this Message.
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """
        Sets the content of this Message.
        Message content

        :param content: The content of this Message.
        :type: str
        """
        self._content = content

    @property
    def scope(self):
        """
        Gets the scope of this Message.
        The audience scope that this message should reach

        :return: The scope of this Message.
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """
        Sets the scope of this Message.
        The audience scope that this message should reach

        :param scope: The scope of this Message.
        :type: str
        """
        allowed_values = ["CLUSTER", "CUSTOMER", "USER"]
        if scope not in allowed_values:
            raise ValueError(
                "Invalid value for `scope`, must be one of {0}"
                .format(allowed_values)
            )
        self._scope = scope

    @property
    def start_epoch_millis(self):
        """
        Gets the start_epoch_millis of this Message.
        When this message will begin to be displayed, in epoch millis

        :return: The start_epoch_millis of this Message.
        :rtype: int
        """
        return self._start_epoch_millis

    @start_epoch_millis.setter
    def start_epoch_millis(self, start_epoch_millis):
        """
        Sets the start_epoch_millis of this Message.
        When this message will begin to be displayed, in epoch millis

        :param start_epoch_millis: The start_epoch_millis of this Message.
        :type: int
        """
        self._start_epoch_millis = start_epoch_millis

    @property
    def end_epoch_millis(self):
        """
        Gets the end_epoch_millis of this Message.
        When this message will stop being displayed, in epoch millis

        :return: The end_epoch_millis of this Message.
        :rtype: int
        """
        return self._end_epoch_millis

    @end_epoch_millis.setter
    def end_epoch_millis(self, end_epoch_millis):
        """
        Sets the end_epoch_millis of this Message.
        When this message will stop being displayed, in epoch millis

        :param end_epoch_millis: The end_epoch_millis of this Message.
        :type: int
        """
        self._end_epoch_millis = end_epoch_millis

    @property
    def display(self):
        """
        Gets the display of this Message.
        The form of display for this message

        :return: The display of this Message.
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """
        Sets the display of this Message.
        The form of display for this message

        :param display: The display of this Message.
        :type: str
        """
        allowed_values = ["BANNER", "TOASTER"]
        if display not in allowed_values:
            raise ValueError(
                "Invalid value for `display`, must be one of {0}"
                .format(allowed_values)
            )
        self._display = display

    @property
    def title(self):
        """
        Gets the title of this Message.
        Title of this message

        :return: The title of this Message.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """
        Sets the title of this Message.
        Title of this message

        :param title: The title of this Message.
        :type: str
        """
        self._title = title

    @property
    def severity(self):
        """
        Gets the severity of this Message.
        Message severity

        :return: The severity of this Message.
        :rtype: str
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """
        Sets the severity of this Message.
        Message severity

        :param severity: The severity of this Message.
        :type: str
        """
        allowed_values = ["MARKETING", "INFO", "WARN", "SEVERE"]
        if severity not in allowed_values:
            raise ValueError(
                "Invalid value for `severity`, must be one of {0}"
                .format(allowed_values)
            )
        self._severity = severity

    @property
    def read(self):
        """
        Gets the read of this Message.
        A derived field for whether the current user has read this message

        :return: The read of this Message.
        :rtype: bool
        """
        return self._read

    @read.setter
    def read(self, read):
        """
        Sets the read of this Message.
        A derived field for whether the current user has read this message

        :param read: The read of this Message.
        :type: bool
        """
        self._read = read

    @property
    def source(self):
        """
        Gets the source of this Message.
        Message source.  System messages will com from 'system@wavefront.com'

        :return: The source of this Message.
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """
        Sets the source of this Message.
        Message source.  System messages will com from 'system@wavefront.com'

        :param source: The source of this Message.
        :type: str
        """
        self._source = source

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

