# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class SavedSearch(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SavedSearch - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'query': 'dict(str, str)',
            'created_epoch_millis': 'int',
            'updated_epoch_millis': 'int',
            'updater_id': 'str',
            'creator_id': 'str',
            'user_id': 'str',
            'entity_type': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'query': 'query',
            'created_epoch_millis': 'createdEpochMillis',
            'updated_epoch_millis': 'updatedEpochMillis',
            'updater_id': 'updaterId',
            'creator_id': 'creatorId',
            'user_id': 'userId',
            'entity_type': 'entityType'
        }

        self._id = None
        self._query = None
        self._created_epoch_millis = None
        self._updated_epoch_millis = None
        self._updater_id = None
        self._creator_id = None
        self._user_id = None
        self._entity_type = None

    @property
    def id(self):
        """
        Gets the id of this SavedSearch.


        :return: The id of this SavedSearch.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this SavedSearch.


        :param id: The id of this SavedSearch.
        :type: str
        """
        self._id = id

    @property
    def query(self):
        """
        Gets the query of this SavedSearch.
        The map corresponding to the search query.  The key is the name of the query, and the value is a JSON representation of the query

        :return: The query of this SavedSearch.
        :rtype: dict(str, str)
        """
        return self._query

    @query.setter
    def query(self, query):
        """
        Sets the query of this SavedSearch.
        The map corresponding to the search query.  The key is the name of the query, and the value is a JSON representation of the query

        :param query: The query of this SavedSearch.
        :type: dict(str, str)
        """
        self._query = query

    @property
    def created_epoch_millis(self):
        """
        Gets the created_epoch_millis of this SavedSearch.


        :return: The created_epoch_millis of this SavedSearch.
        :rtype: int
        """
        return self._created_epoch_millis

    @created_epoch_millis.setter
    def created_epoch_millis(self, created_epoch_millis):
        """
        Sets the created_epoch_millis of this SavedSearch.


        :param created_epoch_millis: The created_epoch_millis of this SavedSearch.
        :type: int
        """
        self._created_epoch_millis = created_epoch_millis

    @property
    def updated_epoch_millis(self):
        """
        Gets the updated_epoch_millis of this SavedSearch.


        :return: The updated_epoch_millis of this SavedSearch.
        :rtype: int
        """
        return self._updated_epoch_millis

    @updated_epoch_millis.setter
    def updated_epoch_millis(self, updated_epoch_millis):
        """
        Sets the updated_epoch_millis of this SavedSearch.


        :param updated_epoch_millis: The updated_epoch_millis of this SavedSearch.
        :type: int
        """
        self._updated_epoch_millis = updated_epoch_millis

    @property
    def updater_id(self):
        """
        Gets the updater_id of this SavedSearch.


        :return: The updater_id of this SavedSearch.
        :rtype: str
        """
        return self._updater_id

    @updater_id.setter
    def updater_id(self, updater_id):
        """
        Sets the updater_id of this SavedSearch.


        :param updater_id: The updater_id of this SavedSearch.
        :type: str
        """
        self._updater_id = updater_id

    @property
    def creator_id(self):
        """
        Gets the creator_id of this SavedSearch.


        :return: The creator_id of this SavedSearch.
        :rtype: str
        """
        return self._creator_id

    @creator_id.setter
    def creator_id(self, creator_id):
        """
        Sets the creator_id of this SavedSearch.


        :param creator_id: The creator_id of this SavedSearch.
        :type: str
        """
        self._creator_id = creator_id

    @property
    def user_id(self):
        """
        Gets the user_id of this SavedSearch.
        The user for whom this search is saved

        :return: The user_id of this SavedSearch.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this SavedSearch.
        The user for whom this search is saved

        :param user_id: The user_id of this SavedSearch.
        :type: str
        """
        self._user_id = user_id

    @property
    def entity_type(self):
        """
        Gets the entity_type of this SavedSearch.
        The Wavefront entity type over which to search

        :return: The entity_type of this SavedSearch.
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """
        Sets the entity_type of this SavedSearch.
        The Wavefront entity type over which to search

        :param entity_type: The entity_type of this SavedSearch.
        :type: str
        """
        allowed_values = ["DASHBOARD", "ALERT", "MAINTENANCE_WINDOW", "NOTIFICANT", "EVENT", "SOURCE", "EXTERNAL_LINK", "AGENT", "CLOUD_INTEGRATION"]
        if entity_type not in allowed_values:
            raise ValueError(
                "Invalid value for `entity_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._entity_type = entity_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

